#include <bits/stdc++.h>
using namespace std;

int a[1000005];
int main()
{
    int n,k;
    cin>>n>>k;
    int br1=0;
    int br2=0;
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        if(a[i]==1)br1++;
        if(a[i]==2)br2++;
    }
    if(br2<k)
    {
        if(br1<k)cout<<0;
        else cout<<1;
    }
    else
    {
        if(br1<k)cout<<2;
        else
        {
            bool sr1=0;
            bool sr2=0;
            int grps=0;
            for(int i=0;i<n;i++)
            {
                if(sr1 && sr2)
                {
                    grps++;
                    sr1=0;
                    sr2=0;
                }
                if(a[i]==1)sr1=1;
                if(a[i]==2)sr2=2;
            }
            if(grps>=k)cout<<3;
            else cout<<2;
        }
    }


}
